/*******************************************************************************
 * FoxAIAction_StaggerSelection generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxAIAction_StaggerSelection extends FoxAIAction_Selection
    native(AI)
    editinlinenew
    hidecategories(Object);

struct native StaggerThrushold
{
    var() const int Amount;
    var() const string ActionName;
    var() const float MaxHealthRatio;

    structdefaultproperties
    {
        Amount=0
        ActionName=""
        MaxHealthRatio=1.0
    }
};

var() const array<StaggerThrushold> TripThresholds;
var() const array<StaggerThrushold> StaggerThresholds;
var() const float DamageTimeThreshold;
var() const float StaggerTimeThreshold;
var transient float LastHitTime;
var transient int AmountSinceStagger;
var transient float LastStaggerTime;
var() const float StaggerRate;

// Export UFoxAIAction_StaggerSelection::execProcessBehaviorEvent(FFrame&, void* const)
native function bool ProcessBehaviorEvent(string EventName, optional Actor EventInstigator, optional Actor EventRecipient, optional Vector EventLocation);

defaultproperties
{
    TripThresholds(0)=(Amount=150,ActionName="TripLong",MaxHealthRatio=1.0)
    TripThresholds(1)=(Amount=100,ActionName="TripMedium",MaxHealthRatio=1.0)
    TripThresholds(2)=(Amount=67,ActionName="TripShort",MaxHealthRatio=1.0)
    TripThresholds(3)=(Amount=25,ActionName="TripQuick",MaxHealthRatio=1.0)
    StaggerThresholds(0)=(Amount=0,ActionName="Stagger",MaxHealthRatio=1.0)
    DamageTimeThreshold=2.0
    StaggerRate=0.50
    begin object name=TripQuick class=FoxAIAction_SpecialMove
        SpecialMoveStateName=SpecialMove_Trip
        AbilityName="TripQuick"
    object end
    // Reference: FoxAIAction_SpecialMove'Default__FoxAIAction_StaggerSelection.TripQuick'
    SubActions(0)=TripQuick
    begin object name=TripShort class=FoxAIAction_SpecialMove
        SpecialMoveStateName=SpecialMove_TripShort
        AbilityName="TripShort"
    object end
    // Reference: FoxAIAction_SpecialMove'Default__FoxAIAction_StaggerSelection.TripShort'
    SubActions(1)=TripShort
    begin object name=TripMedium class=FoxAIAction_SpecialMove
        SpecialMoveStateName=SpecialMove_TripMedium
        AbilityName="TripMedium"
    object end
    // Reference: FoxAIAction_SpecialMove'Default__FoxAIAction_StaggerSelection.TripMedium'
    SubActions(2)=TripMedium
    begin object name=TripLong class=FoxAIAction_SpecialMove
        SpecialMoveStateName=SpecialMove_TripLong
        AbilityName="TripLong"
    object end
    // Reference: FoxAIAction_SpecialMove'Default__FoxAIAction_StaggerSelection.TripLong'
    SubActions(3)=TripLong
    begin object name=Stagger class=FoxAIAction_SpecialMove
        SpecialMoveStateName=SpecialMove_Stagger
        AbilityName="Stagger"
    object end
    // Reference: FoxAIAction_SpecialMove'Default__FoxAIAction_StaggerSelection.Stagger'
    SubActions(4)=Stagger
}